from gpiozero import LED, Button # Import the required modules
from time import sleep
from random import uniform
import threading

led2 = LED(17)
led = LED(4) # Create an LED object connected to GPIO pin 4
right_button = Button(16) # Create a Button object connected to GPIO pin 16
left_button = Button(12) # Create a Button object connected to GPIO pin 12

left_name = input('left player name is ') # Get the left player's name from user input
right_name = input('right player name is ') # Get the right player's name from user input
left_score = 0 # Initialize the left player's score to 0
right_score = 0 # Initialize the right player's score to 0

def pressed(button):
    global left_score, right_score # Access the global score variables
    winner_name = left_name if button.pin.number == 12 else right_name # Determine the winner's name based on the pressed button
    print(winner_name + ' won the game') # Print the winner's name
    led.off() # Turn off the LED
    led2.on()
    if button.pin.number == 12:
        left_score += 1 # Increment the left player's score
    else:
        right_score += 1 # Increment the right player's score
    print('Score -', left_name + ':', left_score, right_name + ':', right_score) # Print the updated scores
    threading.Thread(target=turn_on_led_after_delay).start() # Start a new thread to turn on the LED after a random delay

right_button.when_pressed = pressed # Call the pressed function when the right button is pressed
left_button.when_pressed = pressed # Call the pressed function when the left button is pressed

def turn_on_led_after_delay():
    sleep_duration = uniform(5, 10) # Generate a random sleep duration between 5 and 10 seconds
    print('LED will turn on again after', sleep_duration, 'seconds...') # Print the duration until LED turn on
    sleep(sleep_duration) # Sleep for the random duration
    led.on() # Turn on the LED
    led2.off()

# Initial LED turn on
turn_on_led_after_delay()

# Keep the main thread running to listen for button presses
while True:
    pass